package com.wechi.adweb.bridge.google.ads.dto;

import com.wechi.adweb.bridge.exception.DataException;

import lombok.Data;

import org.apache.commons.lang3.StringUtils;

/**
 * @author wfansh
 */
@Data
public class ReportRequestDTO {

    private String customerId;

    private String refreshToken;

    private String startDate;

    private String endDate;

    private int limit;

    /** Ensures the limit value is positive by defaulting to 1000. */
    public int getLimit() {
        return limit > 0 ? limit : 1000;
    }

    public String toDateClause() throws DataException {
        if (StringUtils.isEmpty(startDate) || StringUtils.isEmpty(endDate)) {
            throw new DataException(
                    String.format(
                            "Invalid date range, startDate = %s, endDate = %s",
                            startDate, endDate));
        }

        return String.format("segments.date BETWEEN '%s' AND '%s'", startDate, endDate);
    }
}
