package com.wechi.adweb.bridge.google.analytics.dto.report;

import lombok.Data;

import java.util.List;

/**
 * @author wfansh
 */
@Data
public class GAReportRequestDTO {

    private String propertyResourceName;

    private ReportType reportType;

    private String startDate;

    private String endDate;

    /** Overrides defaults in {@link ReportType}. */
    private List<String> metrics;

    /** Overrides defaults in {@link ReportType}. */
    private List<String> dimensions;

    /** Overrides defaults in {@link ReportType}. */
    private String orderBy;

    /** Overrides defaults in {@link ReportType}. */
    private OrderByType orderByType;

    /** Overrides defaults in {@link ReportType}. */
    private Boolean orderByDesc;

    private int limit;

    /**
     * Ensures the limit value is positive by defaulting to 250,000. The API returns a maximum of
     * 250,000 rows per request. See
     * https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1beta/properties/runReport
     */
    public int getLimit() {
        return limit > 0 ? limit : 250_000;
    }
}
