package com.wechi.adweb.bridge.google.gtm.service;

import com.wechi.adweb.bridge.exception.DataException;
import com.wechi.adweb.bridge.google.gtm.dto.GTMContainerDTO;
import com.wechi.adweb.bridge.util.JsonUtils;

import org.apache.commons.lang3.RandomStringUtils;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

/**
 * @author wfansh
 */
@SpringBootTest
public class GTMServiceTest {

    @Autowired private GTMService gtmService;

    private final String accountResourceName = "accounts/6000226571";

    private final String gaMeasurementId = "G-LHFYWQKHJV";

    @Test
    @Disabled("Disabled due to operations on the production account.")
    void testCreateContainer() throws DataException, InterruptedException {
        GTMContainerDTO gtmContainer =
                gtmService.createContainer(
                        accountResourceName, "AdWeb3 Test #" + RandomStringUtils.randomNumeric(5));

        // ASYNC method.
        gtmService.initContainer(
                accountResourceName, gtmContainer.getResourceName(), gaMeasurementId, "111");

        System.out.println(JsonUtils.toJson(gtmContainer));

        // Waits for the readiness of container initialization.
        Thread.sleep(5000);
        gtmService.deleteContainer(gtmContainer.getResourceName());
    }
}
