package com.wechi.adweb.bridge.matomo;

import com.wechi.adweb.bridge.exception.DataException;
import com.wechi.adweb.bridge.matomo.dto.MatomoSiteDTO;
import com.wechi.adweb.bridge.matomo.service.MatomoService;
import com.wechi.adweb.bridge.util.JsonUtils;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

/**
 * @author wfansh
 */
@SpringBootTest
public class MatomoServiceTest {

    @Autowired private MatomoService matomoService;

    @Test
    void testListSites() {
        List<MatomoSiteDTO> matomoSites = matomoService.listSites();

        System.out.println(JsonUtils.toJson(matomoSites));
    }

    @Test
    @Disabled("Disabled due to operations on the production account.")
    void testCreateSite() throws DataException {
        MatomoSiteDTO matomoSite = matomoService.createSite("未迟官网", "https://www.wechi.vip/");
        matomoSite = matomoService.getSite(matomoSite.getSiteId());

        System.out.println(matomoSite.getTrackingCode());
        System.out.println(JsonUtils.toJson(matomoSite));

        matomoService.deleteSite(matomoSite.getSiteId());
    }
}
